;**********************************************************************
;
;	File:	FORDSONY.INC
;
;	Desc:	Definitions for PIC12C508-based Ford-to-Sony stalk adapter.
;
;	Notes:	-
;
;**********************************************************************

; Processor configuration
	__CONFIG	_CP_OFF & _IntRC_OSC & _MCLRE_OFF & _WDT_ON
	__IDLOCS	H'FFFF'

; GPIO bits
OUT23K6	EQU	0			; drive 0 or keep in tri-state
OUT12K1	EQU	1			; drive 0 or keep in tri-state
RCINPUT	EQU	2			; drive 1 or use as input
;	EQU	3			; unused input-only GPIO
OUT2K2	EQU	4			; drive 0 or keep in tri-state
OUT16K8	EQU	5			; drive 0 or keep in tri-state

; Constants, Tcy = 1.00 us
REPEAT_COUNT	EQU	H'3F'		; number of same inputs required - 1

VOL_DOWN	EQU	.10		; < 10 us
VOL_UP		EQU	.23		; < 23 us
SEEK_UP		EQU	.44		; < 44 us
SEEK_DOWN	EQU	.81		; < 81 us
MODE		EQU	.310		; < 310 us

VOL_DOWN_LOOP	EQU	(VOL_DOWN - 4 + 1) / 3
VOL_UP_LOOP	EQU	(VOL_UP - VOL_DOWN - 6 + 1) / 3
SEEK_UP_LOOP	EQU	(SEEK_UP - VOL_UP - 6 + 1) / 3
SEEK_DOWN_LOOP	EQU	(SEEK_DOWN - SEEK_UP - 6 + 1) / 3
MODE_LOOP	EQU	(MODE - SEEK_DOWN - 6 + 1) / 3

; Register values
GPIO_VALUE	EQU	B'11000100'
OPTION_VALUE	EQU	B'11011001'	; no T0CKI, 1/2 prescaler for WDT

TRIS_IDLE	EQU	B'11111111'
TRIS_CHARGE	EQU	B'11111011'

TRIS_VOL_DOWN	EQU	B'11111110'	; ~21K4
TRIS_VOL_UP	EQU	B'11011111'	; ~16K8
TRIS_SEEK_UP	SET	B'11111100'	; ~8K8
TRIS_SEEK_DOWN	SET	B'11111101'	; ~12K1
TRIS_SOURCE	EQU	B'11101111'	; ~2K2

;TRIS_SEEK_UP	SET	B'11111101'	; uncomment for reverse SEEK directions
;TRIS_SEEK_DOWN	SET	B'11111100'	; 

; Rekistereit
TRIS_IMAGE	EQU	07		; current TRIS value
LAST_INPUT	EQU	08		; previous detected input
INPUT_COUNTER	EQU	09		; countdown of same inputs
COUNTER		EQU	0A		; used for delays

